﻿using System;
using System.Text;

using System.Drawing;
using System.Runtime.InteropServices;
using System.Diagnostics;

namespace GradientionSample
{
    public enum FillDirection
    {
        // 水平にグラデーションで塗りつぶします
        LeftToRight = Win32.GRADIENT_FILL.GRADIENT_FILL_RECT_H,

        // 垂直にグラデーションで塗りつぶします
        TopToBottom = Win32.GRADIENT_FILL.GRADIENT_FILL_RECT_V
    }

    public sealed class GradientFill
    {
        public static bool Fill(
            Graphics gr, Rectangle rc,
            Color startColor, Color endColor,
            FillDirection fillDir)
        {
            // 頂点の座標と色を指定
            Win32.TRIVERTEX[] tva = new Win32.TRIVERTEX[2];
            tva[0] = new Win32.TRIVERTEX(rc.X, rc.Y, startColor);
            tva[1] = new Win32.TRIVERTEX(rc.Right, rc.Bottom, endColor);

            // どのTRIVERTEXの値を使用するかインデックスを指定
            Win32.GRADIENT_RECT[] gra
                = new Win32.GRADIENT_RECT[] { new Win32.GRADIENT_RECT(0, 1) };

            // GradientFill関数の呼び出し
            IntPtr hdc = gr.GetHdc();
            bool b = Win32.GradientFill(
                hdc, tva, (uint)tva.Length,
                gra, (uint)gra.Length, (uint)fillDir);
            gr.ReleaseHdc(hdc);
            return b;
        }
    }
}